package autofeature.intermediate;

import java.util.ArrayList;
import java.util.List;
import org.antlr.runtime.tree.CommonTree;
import static autofeature.intermediate.TreeUtil.*;

public class State {

    private List<Event> events;
    private final AST ast;

    public final Automaton automaton;

    public State(Automaton a, AST ast) {
        this.automaton = a;
        this.ast = ast;
    }

    public String getName() {
        return ast.root.getText();
    }

    public List<Event> getEvents() {
        if (events == null) {
            events = new ArrayList<Event>();
            for (CommonTree event : childs(ast.root)) {
                events.add(new Event(ast.asAst(event)));
            }
        }
        return events;

    }
}
