#include "Email.h"
#include "Client.h"

/* Introductions of Automaton 'EncryptConsistently3' */
introduce(): intype(struct email) {
int mail_is_sensitive;
}



/* EncryptConsistently3 */
/* Event init_email */
before(struct email * msg): execution(void init_email(struct email *)) && args(msg) {

        printf("before init\n");
        msg->mail_is_sensitive = -1;
        printf("msg->mail_is_sensitive: %d\n", msg->mail_is_sensitive);
    
}
/* Event cloneEmail */
after(struct email * clone, struct email * msg): execution(struct email * cloneEmail(struct email *)) && args(msg) && result(clone) {

        printf("after clone\n");
        clone->mail_is_sensitive = msg->mail_is_sensitive;
        printf("msg->mail_is_sensitive: %d\n", msg->mail_is_sensitive);
        printf("clone->mail_is_sensitive: %d\n", clone->mail_is_sensitive);
    
}
/* Event mail */
before(struct email * msg): execution(void mail(struct client *, struct email *)) && args(struct client *, msg) {

        printf("before mail\n");
        printf("mail_is_sensitive: %d\n", msg->mail_is_sensitive);
        if (msg->mail_is_sensitive == -1) {
            msg->mail_is_sensitive = isEncrypted(msg);
        } else if (msg->mail_is_sensitive != isEncrypted(msg)) {
            printf("ERROR!! Safety property violated!!\n");
        }
    
}
